var app = app || {};

app.Lists = (app.Lists || {});

function fileChange()
{
	//FileList Objekt aus dem Input Element mit der ID "fileA"
	var fileList = document.getElementById("fileA").files;

	//File Objekt (erstes Element der FileList)
	var file = fileList[0];

	//File Objekt nicht vorhanden = keine Datei ausgewählt oder vom Browser nicht unterstützt
	if(!file)
			return;

	//document.getElementById("fileName").innerHTML = 'Dateiname: ' + file.name;
	//document.getElementById("fileSize").innerHTML = 'Dateigröße: ' + file.size + ' B';
	//document.getElementById("fileType").innerHTML = 'Dateitype: ' + file.type;
	jQuery('#fileName').val(file.name);
	jQuery('#fileSize').val(file.size + ' B');
	document.getElementById("progress").value = 0;
	document.getElementById("prozent").innerHTML = "0%";
	jQuery('#fileUpload').prop('disabled', false);
	jQuery('#fileAbort').prop('disabled', false);
}

var client = null;
 
function uploadFile()
{
	//Wieder unser File Objekt
	var file = document.getElementById("fileA").files[0];
	//FormData Objekt erzeugen
	var formData = new FormData();
	//XMLHttpRequest Objekt erzeugen
	client = new XMLHttpRequest();

	var prog = document.getElementById("progress");

	if(!file)
		return;

	prog.value = 0;
	prog.max = 100;

	//Fügt dem formData Objekt unser File Objekt hinzu
	formData.append("description", jQuery("#fileDesc").val());
	formData.append("file", file);

	client.onerror = function(e) {
		alert("onError");
	};

	client.onload = function(e) {
		document.getElementById("prozent").innerHTML = "100%";
		prog.value = prog.max;
			
		var att = new app.Attachment(JSON.parse(e.target.response));
		att.set({description: jQuery('#fileDesc').val()});
		if(app.AttachTab === undefined || app.AttachTab === null) {
			app.AttachTab = new app.AttachmentListView({model: new app.AttachmentCollection()});
			jQuery('#listAttachment').html(app.AttachTab.render().el);
		}
		app.AttachTab.model.add(att);
		jQuery('#fileUpload').prop('disabled', true);
		jQuery('#fileAbort').prop('disabled', true);
	};

	client.upload.onprogress = function(e) {
		var p = Math.round(100 / e.total * e.loaded);
		document.getElementById("progress").value = p;            
		document.getElementById("prozent").innerHTML = p + "%";
	};

	client.onabort = function(e) {
		alert("Upload abgebrochen");
	};

	client.open("POST", "attachment/store");
	client.send(formData);
}

function uploadAbort() {
	if(client instanceof XMLHttpRequest)
		//Bricht die aktuelle Übertragung ab
		client.abort();
}

function uploadButton() {
	document.getElementById("progress").value = 0;
	jQuery('#fileA').hide();
	jQuery('#btFileA').on('click', function() {
		jQuery('#fileA').trigger('click');
	});
	jQuery('#fileUpload').prop('disabled', true);
	jQuery('#fileAbort').prop('disabled', true);
}

////////////////////////////////////////////////////////////////////////////////
///// Default Classes
////////////////////////////////////////////////////////////////////////////////

// Default List View
app.DefaultListView = Backbone.View.extend({
		
	tagName: 'ul',

	initialize: function() {
		this.model.bind("reset", this.render, this);
		var me = this;
		this.model.bind("add", function(project) {
			jQuery(me.el).append(new app[me.itemListView]({model: project}).render().el);
		});
	},
	
	render: function(eventName) {
		var me = this;
		_.each(this.model.models, function(project) {
			jQuery(this.el).append(new app[me.itemListView]({model: project}).render().el);
		}, this);
		return this;
	}
});


// Default List Item View
app.DefaultListItemView = Backbone.View.extend({
	
	tagName: 'li',
	
	initialize: function() {
		this.model.bind("change", this.render, this);
		this.model.bind("destroy", this.close, this);
	},
	
	render: function(eventName) {
		jQuery(this.el).html(this.template(this.model.toJSON()));
		return this;
	},
	
	close: function() {
		jQuery(this.el).unbind();
		jQuery(this.el).remove();
	}
});

// Default Detail View
app.DefaultView = Backbone.View.extend({
	
	initialize: function() {
		this.model.bind("change", this.render, this);
	},
	
	render: function(eventName) {
		if(this.isRender) {
			for(var x in this.fields) {
				var id = this.fields[x];
				var type = jQuery('#' + id).attr('type');
				switch(type) {
				case 'checkbox':
					jQuery('#' + id).prop('checked', this.model.get(x));
					break;
				default:
					jQuery('#' + id).val(this.model.get(x));
					break;
				}
			}
		} else {
			jQuery(this.el).html(this.template(this.model.toJSON()));
			this.isRender = true;
		}
		if(this.renderInfo)
			this.renderInfo();
		return this;
	},
	
	setModel: function(model) {
		this.model.unbind(null, null, this);
		this.model = model;
		this.initialize();
		this.render();
	},
	
	events: {
		"change input": "change",
		"click .save": "saveRow",
		"click .delete": "deleteRow"
	},
	
	change: function(event) {
		var target = event.target;
		//console.log('changing ' + target.id + ' from: ' + target.defalutValue + ' to: ' + target.value);
	},
	
	saveRow: function() {
		var doc = {};
		for(var x in this.fields) {
			if(x != '_key') {
				var id = this.fields[x];
				var type = jQuery('#' + id).attr('type');
				switch(type) {
				case 'checkbox':
					doc[x] = jQuery('#' + id).prop('checked');
					break;
				default:
					doc[x] = jQuery('#'+id).val();
					break;
				}
			}
		}
		this.model.set(doc);
		if(this.model.isValid()) {
			if(this.model.isNew()) {
				var me = this;
				this.collection.create(this.model, {
					success: function() {
						app.PR.navigate(me.navpoint + '/' + me.model.id, false);
					}
				});
			} else
				this.model.save();
		} else
			alert(this.model.validationError);
		return false;
	},
	
	deleteRow: function() {
		this.model.destroy({
			success: function() {
				window.history.back();
			}
		});
		return false;
	},
	
	close: function() {
		jQuery(this.el).unbind();
		jQuery(this.el).empty();
	}
});

// Default Header
app.DefaultHeaderView = Backbone.View.extend({
		
	initialize: function() {
		this.render();
	},
	
	render: function(eventName) {
		jQuery(this.el).html(this.template());
		return this;
	},
	
	events: {
		"click .new": "newRow",
		"click .refresh": "refreshList"
	},
	
	newRow: function(event) {
		app.PR.navigate(this.navpoint + "/new", true);
		return false;
	},
	
	refreshList: function(event) {
		app.PR.navigate(this.navpoint + "/list", true);
		return false;
	}
});


////////////////////////////////////////////////////////////////////////////////
// Project Model
// ----------

// Our basic **Todo** model has `title`, `order`, and `completed` attributes.
app.Project = Backbone.Model.extend({
	// Default attributes for the todo
	// and ensure that each todo created has `title` and `completed` keys.
	defaults: {
		_key: null,
		name: '',
		dftAssigned: ''
	},
	idAttribute: '_key',

	// Added by mchacki
	// URL points to the Aye-Aye Application
	url: function() {
		if (this.get("_key") !== undefined && this.get("_key") !== null) {
			// If the Todo-Event is existing it has a _key attribute,
			// so we can use the id route.
			return 'project/' + encodeURIComponent(this.get("_key"));
		}
		// If we create a new Projekt-Event we send the POST without the id.
		this.set("_key", undefined);
		return 'project';
	},

	// Added by mchacki
	// Overwritten the isNew check of Backbone.
	// The ArangoDB creates a unique _id for ids
	// not an id as expected by backbone.
	isNew: function() {
		return (this.get("_key") === undefined || this.get("_key") === null);
	},
	
	validate: function(attrs, options) {
		if(attrs.name === undefined || attrs.name === null || attrs.name.trim().length == 0)
			return "Bitte einen Namen eingeben.";
	}
});

// Project Collection
// ---------------

// The collection of todos is backed by *localStorage* instead of a remote
// server.
app.ProjectCollection = Backbone.Collection.extend({
	// Reference to this collection's model.
	model: app.Project,
	
	// Modified by mchacki
	// URL points to the Aye-Aye Application
	url: "project",

	// Filter down the list of all todo items that are finished.
	/*completed: function () {
		return this.filter(function (todo) {
			return todo.get('completed');
		});
	},

	// Filter down the list to only todo items that are still not finished.
	remaining: function () {
		return this.without.apply(this, this.completed());
	},

	// We keep the Todos in sequential order, despite being saved by unordered
	// GUID in the database. This generates the next order number for new items.
	nextOrder: function () {
		if (!this.length) {
			return 1;
		}
		return this.last().get('order') + 1;
	},*/

	// Project are sorted by their original insertion order.
	comparator: function (project) {
		return project.get('name');
	}
});

// Project List View
app.ProjectListView = app.DefaultListView.extend({
	itemListView: 'ProjectListItemView'
});

// Project List Item View
app.ProjectListItemView = app.DefaultListItemView.extend({
	template: _.template(jQuery('#tpl-project-list-item').html())
});

// Project-Detial View
app.ProjectView = app.DefaultView.extend({
	template: _.template(jQuery('#tpl-project-detail').html()),
	fields: {
		'_key': 'projectId',
		'name': 'projectName',
		'dftAssigned': 'projectDftAssigned'
	},
	navpoint: 'project',
	renderInfo: function() {
		if(!this.isRenderInfo) {
			var before = jQuery(this.el).find(".save");
			app.PR.statusList.each(function(status) {
				jQuery('<label>Problem ' + status.get('name') + ':</label><input type="number" id="projectIssue_' + 
					status.get('_key')+'" value="0" disabled/>').insertBefore(before);
			});
			this.isRenderInfo = true;
			setTimeout(function() {
				new app.SelectProjectsView({el: jQuery('#projectDftAssigned'), collection: app.Lists.user, selectedValue: '', defaultFirst: false}).addAll();
			}, 100);
		}
		var btDel = jQuery(this.el).find(".delete");
		jQuery(btDel).prop('disabled', false);
		jQuery.get('project/stat/' + this.model.get('_key'), function(data) {
			_.each(data, function(row) {
				jQuery('#projectIssue_' + row.status).val(row.count);
				if(row.count > 0)
					jQuery(btDel).prop('disabled', true);
			});
		});
	}
});

app.ProjectHeaderView = app.DefaultHeaderView.extend({
	template: _.template(jQuery('#tpl-project-header').html()),
	navpoint: 'project'
});

//////////////////////////////////////////////////////////

// Category Model
// ----------

app.Category = Backbone.Model.extend({
	defaults: {
		_key: null,
		name: '',
		dftAssigned: ''
	},
	idAttribute: '_key',

	url: function() {
		if (this.get("_key") !== undefined && this.get("_key") !== null) {
			return 'category/' + encodeURIComponent(this.get("_key"));
		}
		this.set("_key", undefined);
		return 'category';
	},

	isNew: function() {
		return (this.get("_key") === undefined || this.get("_key") === null);
	},
	
	validate: function(attrs, options) {
		if(attrs.name === undefined || attrs.name === null || attrs.name.trim().length == 0)
			return "Bitte einen Namen eingeben.";
	}
});

// Category Collection
// ---------------

app.CategoryCollection = Backbone.Collection.extend({
	model: app.Category,
	
	url: "category",

	comparator: function (category) {
		return category.get('name');
	}
});

// Category List View
app.CategoryListView = app.DefaultListView.extend({
	itemListView: 'CategoryListItemView'
});
		
// Category List Item View
app.CategoryListItemView = app.DefaultListItemView.extend({
	template: _.template(jQuery('#tpl-category-list-item').html())
});

// Category-Detial View
app.CategoryView = app.DefaultView.extend({
		
	template: _.template(jQuery('#tpl-category-detail').html()),
	
	fields: {
		'_key': 'categoryId',
		'name': 'categoryName',
		'dftAssigned': 'categoryDftAssigned'
	},
	navpoint: 'category',
	renderInfo: function() {
		if(!this.isRenderInfo) {
			var before = jQuery(this.el).find(".save");
			app.PR.statusList.each(function(status) {
				jQuery('<label>Problem ' + status.get('name') + ':</label><input type="number" id="categoryIssue_' + 
					status.get('_key')+'" value="0" disabled/>').insertBefore(before);
			});
			this.isRenderInfo = true;
			setTimeout(function() {
				new app.SelectProjectsView({el: jQuery('#categoryDftAssigned'), collection: app.Lists.user, selectedValue: '', defaultFirst: false}).addAll();
			}, 100);
		}
		var btDel = jQuery(this.el).find(".delete");
		jQuery(btDel).prop('disabled', false);
		jQuery.get('category/stat/' + this.model.get('_key'), function(data) {
			_.each(data, function(row) {
				jQuery('#categoryIssue_' + row.status).val(row.count);
				if(row.count > 0)
					jQuery(btDel).prop('disabled', true);
			});
		});
	}
	
});

app.CategoryHeaderView = app.DefaultHeaderView.extend({
	template: _.template(jQuery('#tpl-category-header').html()),
	navpoint: 'category'
});

// Status Model
// ----------

app.Status = Backbone.Model.extend({
	defaults: {
		_key: null,
		name: '',
		sort: 0,
		dftStatus: false,
		backToCreator: false
	},
	idAttribute: '_key',

	url: function() {
		if (this.get("_key") !== undefined && this.get("_key") !== null) {
			return 'status/' + encodeURIComponent(this.get("_key"));
		}
		this.set("_key", undefined);
		return 'status';
	},

	isNew: function() {
		return (this.get("_key") === undefined || this.get("_key") === null);
	},
	
	validate: function(attrs, options) {
		if(attrs.name === undefined || attrs.name === null || attrs.name.trim().length == 0)
			return "Bitte einen Namen eingeben.";
		if(attrs.sort === undefined || attrs.sort === null)
			return "Bitte einen Sortierung eingeben.";
		if(isNaN(attrs.sort))
			return "Nur Zahlen sind in der Sortierung erlaubt.";
	}
});

// Status Collection
// ---------------

app.StatusCollection = Backbone.Collection.extend({
	model: app.Status,
	
	url: "status",

	comparator: function (status) {
		return status.get('sort');
	}
});

// Status List View
app.StatusListView = app.DefaultListView.extend({
	itemListView: 'StatusListItemView'
});

// Status List Item View
app.StatusListItemView = app.DefaultListItemView.extend({
	template: _.template(jQuery('#tpl-status-list-item').html())
});

// Status-Detial View
app.StatusView = app.DefaultView.extend({
	template: _.template(jQuery('#tpl-status-detail').html()),
	fields: {
		'_key': 'statusId',
		'name': 'statusName',
		'sort': 'statusSort',
		'dftStatus': 'statusDftStatus',
		'backToCreator': 'statusBackToCreator'
	},
	navpoint: 'status',
	renderInfo: function() {
		if(!this.isRenderInfo) {
			var before = jQuery(this.el).find(".save");
			app.PR.statusList.each(function(status) {
				jQuery('<label>Problem ' + status.get('name') + ':</label><input type="number" id="statusIssue_' + 
					status.get('_key')+'" value="0" disabled/>').insertBefore(before);
			});
			this.isRenderInfo = true;
		}
		var btDel = jQuery(this.el).find(".delete");
		jQuery(btDel).prop('disabled', false);
		jQuery.get('status/stat/' + this.model.get('_key'), function(data) {
			_.each(data, function(row) {
				jQuery('#statusIssue_' + row.status).val(row.count);
				if(row.count > 0)
					jQuery(btDel).prop('disabled', true);
			});
		});
	}
});

app.StatusHeaderView = app.DefaultHeaderView.extend({
	template: _.template(jQuery('#tpl-status-header').html()),
	navpoint: 'status'
});


// Priority Model
// ----------

app.Priority = Backbone.Model.extend({
	defaults: {
		_key: null,
		name: '',
		sort: 0,
		dftPriority: false
	},
	idAttribute: '_key',

	url: function() {
		if (this.get("_key") !== undefined && this.get("_key") !== null) {
			return 'priority/' + encodeURIComponent(this.get("_key"));
		}
		this.set("_key", undefined);
		return 'priority';
	},

	isNew: function() {
		return (this.get("_key") === undefined || this.get("_key") === null);
	},
	
	validate: function(attrs, options) {
		if(attrs.name === undefined || attrs.name === null || attrs.name.trim().length == 0)
			return "Bitte einen Namen eingeben.";
		if(attrs.sort === undefined || attrs.sort === null)
			return "Bitte einen Sortierung eingeben.";
		if(isNaN(attrs.sort))
			return "Nur Zahlen sind in der Sortierung erlaubt.";
	}
});

// Priority Collection
// ---------------

app.PriorityCollection = Backbone.Collection.extend({
	model: app.Priority,
	
	url: "priority",

	comparator: function (status) {
		return status.get('sort');
	}
});

// Priority List View
app.PriorityListView = app.DefaultListView.extend({
	itemListView: 'PriorityListItemView'
});

// Priority List Item View
app.PriorityListItemView = app.DefaultListItemView.extend({
	template: _.template(jQuery('#tpl-priority-list-item').html())
});

// Priority-Detial View
app.PriorityView = app.DefaultView.extend({
	template: _.template(jQuery('#tpl-priority-detail').html()),
	fields: {
		'_key': 'priorityId',
		'name': 'priorityName',
		'sort': 'prioritySort',
		'dftPriority': 'priorityDftPriority'
	},
	navpoint: 'priority',
	renderInfo: function() {
		if(!this.isRenderInfo) {
			var before = jQuery(this.el).find(".save");
			app.PR.statusList.each(function(status) {
				jQuery('<label>Problem ' + status.get('name') + ':</label><input type="number" id="priorityIssue_' + 
					status.get('_key')+'" value="0" disabled/>').insertBefore(before);
			});
			this.isRenderInfo = true;
		}
		var btDel = jQuery(this.el).find(".delete");
		jQuery(btDel).prop('disabled', false);
		jQuery.get('priority/stat/' + this.model.get('_key'), function(data) {
			_.each(data, function(row) {
				jQuery('#priorityIssue_' + row.status).val(row.count);
				if(row.count > 0)
					jQuery(btDel).prop('disabled', true);
			});
		});
	}
});

app.PriorityHeaderView = app.DefaultHeaderView.extend({
	template: _.template(jQuery('#tpl-priority-header').html()),
	navpoint: 'priority'
});

// User List View
app.UserListView = app.DefaultListView.extend({
	itemListView: 'UserListItemView'
});

// User List Item View
app.UserListItemView = app.DefaultListItemView.extend({
	template: _.template(jQuery('#tpl-user-list-item').html())
});

// User-Detial View
app.UserView = app.DefaultView.extend({
	template: _.template(jQuery('#tpl-user-detail').html()),
	fields: {
		'_key': 'userId',
		'firstName': 'userFirstName',
		'lastName': 'userLastName',
		'email': 'userEmail',
		'admin': 'userAdmin'
	},
	navpoint: 'user',
	
	saveRow: function() {
		var p = jQuery('#userPassword').val();
		if(p && p != null && p.length > 0) {
			p = CryptoJS.MD5(p).toString();
		} else
			p = '';
		var userNeu = {
			username: jQuery('#userId').val(),
			password: p,
			firstName: jQuery('#userFirstName').val(),
			lastName: jQuery('#userLastName').val(),
			email: jQuery('#userEmail').val(),
			admin: jQuery('#userAdmin').prop('checked')
		};
		var me = this;
		if(this.model.isNew()) {
			jQuery.post("api/register", JSON.stringify(userNeu), function(data) {
				userNeu._key = userNeu.username;
				userNeu.name = userNeu.firstName + ' ' + userNeu.lastName;
				me.model.set(userNeu);
				app.Lists.user.add(me.model);
			});
		} else {
			jQuery.post("api/update", JSON.stringify(userNeu), function(data) {
				userNeu._key = userNeu.username;
				userNeu.name = userNeu.firstName + ' ' + userNeu.lastName;
				me.model.set(userNeu);
			});
		}
		jQuery('#userPassword').val('');
		return false;
	},
	
	deleteRow: function() {
	}
});

app.UserHeaderView = app.DefaultHeaderView.extend({
	template: _.template(jQuery('#tpl-user-header').html()),
	navpoint: 'user'
});


//////////////////////////////////////////////////////////

// Issue Model
// ----------

app.Issue = Backbone.Model.extend({
	defaults: {
		_key: null,
		title: '',
		project: '',
		category: '',
		status: '',
		priority: '',
		assigned: '',
		createUser: '',
		createDate: '',
		description: '',
		issueNo: 0
	},
	idAttribute: '_key',

	url: function() {
		if (this.get("_key") !== undefined && this.get("_key") !== null) {
			return 'issue/' + encodeURIComponent(this.get("_key"));
		}
		this.set("_key", undefined);
		return 'issue';
	},

	isNew: function() {
		return (this.get("_key") === undefined || this.get("_key") === null);
	},
	
	validate: function(attrs, options) {
		if(attrs.title === undefined || attrs.title === null || attrs.title.trim().length == 0)
			return "Bitte einen Titel eingeben.";
		if(attrs.project === undefined || attrs.project === null || attrs.project.trim().length == 0)
			return "Bitte ein Projekt aussuchen.";
		if(attrs.category === undefined || attrs.category === null || attrs.category.trim().length == 0)
			return "Bitte eine Category aussuchen.";
		if(attrs.status === undefined || attrs.status === null || attrs.status.trim().length == 0)
			return "Bitte einen Status aussuchen.";
		if(attrs.priority === undefined || attrs.priority === null || attrs.priority.trim().length == 0)
			return "Bitte eine Priorität aussuchen.";
		if(attrs.assigned === undefined || attrs.assigned === null || attrs.assigned.trim().length == 0)
			return "Bitte einen Zuständigen aussuchen.";
		if(attrs.description === undefined || attrs.description=== null || attrs.description.trim().length == 0)
			return "Bitte einen Beschreibung eingeben.";
	}
});

// Issue Collection
// ---------------

app.IssueCollection = Backbone.Collection.extend({
	model: app.Issue,
	
	url: "issue",

	comparator: function (issue) {
		return issue.get('name');
	}
});

// Issue List View
app.IssueListView = Backbone.View.extend({
		
	tagName: 'div',
	className: 'tabelle',

	initialize: function() {
		this.model.bind("reset", this.render, this);
		var me = this;
		this.model.bind("add", function(issue) {
			jQuery(me.el).append(new app.IssueListItemView({model: issue}).render().el);
		});
	},
	
	render: function(eventName) {
		if(!this.header) {
			jQuery(this.el).append(new app.IssueListHeaderView().render().el)
			this.header = true;
		}
		_.each(this.model.models, function(issue) {
			jQuery(this.el).append(new app.IssueListItemView({model: issue}).render().el);
		}, this);
		return this;
	},
	
	setModel: function(model) {
		jQuery(this.el).find('.tabelleZeile').remove();
		if(this.model)
			this.model.unbind(this);		
		this.model = model;
		this.initialize();
		this.render();
	}
});

// Issue List Header View
app.IssueListHeaderView = Backbone.View.extend({
	
	tagName: 'div',
	className: 'tabelleHeaderZeile',
	
	template: _.template(jQuery('#tpl-issue-list-header').html()),
	
	events: {
		"click .tabelleHeader": "clickSortBy"
	},
	
	render: function(eventName) {
		jQuery(this.el).html(this.template());
		return this;
	},
	
	clickSortBy: function(event) {
		var sort = jQuery(event.target).attr("name");
		if(sort) {
			var asc = true;
			if(jQuery(event.target).hasClass("sortAsc")) {
				jQuery(event.target).parent().find('.sortAsc, .sortDesc').each(function() {
					var txt = jQuery(this).html();
					var pos = txt.lastIndexOf(' ');
					if(pos >= 0 && pos + 2 == txt.length)
						jQuery(this).html(txt.substring(0, txt.length-2).trim());
					jQuery(this).removeClass("sortAsc").removeClass("sortDesc");
				});
				jQuery(event.target).addClass("sortDesc");
				asc = false;
			} else {
				jQuery(event.target).parent().find('.sortAsc, .sortDesc').each(function() {
					var txt = jQuery(this).html();
					var pos = txt.lastIndexOf(' ');
					if(pos >= 0 && pos + 2 == txt.length)
						jQuery(this).html(txt.substring(0, txt.length-2).trim());
					jQuery(this).removeClass("sortAsc").removeClass("sortDesc");
				});
				jQuery(event.target).addClass("sortAsc");
			}
			jQuery(event.target).html(jQuery(event.target).html() + (asc ? "  &#9650;" : "  &#9660;"));
			app.PR.navigate('issue/list/' + sort + (!asc ? " desc" : ""), true);
		}
	}
});

// Issue List Item View
app.IssueListItemView = Backbone.View.extend({
	
	tagName: 'div',
	className: 'tabelleZeile',
	
	template: _.template(jQuery('#tpl-issue-list-item').html()),
	
	events: {
		"mouseover": "mover",
		"mouseout": "mout",
		"click": "itemselected"
	},
	
	mover: function() {
		jQuery(this.el).css('background-color','#0B4AB6');
		jQuery(this.el).css('color', '#EDE91B');
	},
	mout: function() {
		jQuery(this.el).css('background-color','#FFFFFF');
		jQuery(this.el).css('color', '#000000');
	},
	itemselected: function() {
		jQuery(this.el).find('.issueId')[0].click();
	},
	
	initialize: function() {
		this.model.bind("change", this.render, this);
		this.model.bind("destroy", this.close, this);
	},
	
	render: function(eventName) {
		var obj = this.model.toJSON(), r;
		obj.statusDesc = (obj.status ? (r = app.Lists.status.get(obj.status)) ? r.get("name") : '' : '');
		obj.priorityDesc = (obj.priority ? (r = app.Lists.priority.get(obj.priority)) ? r.get("name") : '' : '');
		obj.projectDesc = (obj.project ? (r = app.Lists.project.get(obj.project)) ? r.get("name") : '' : '');
		obj.categoryDesc = (obj.category ? (r = app.Lists.category.get(obj.category)) ? r.get("name") : '' : '');
		obj.createUserName = (obj.createUser ? (r = app.Lists.user.get(obj.createUser)) ? r.get("name") : '' : '');
		obj.assignedName = (obj.assigned ? (r = app.Lists.user.get(obj.assigned)) ? r.get("name") : '' : '');
		jQuery(this.el).html(this.template(obj));
		return this;
	},
	
	close: function() {
		jQuery(this.el).unbind();
		jQuery(this.el).remove();
	}
});

// Issue-Detial View
app.IssueView = Backbone.View.extend({
		
	template: _.template(jQuery('#tpl-issue-detail').html()),
	
	initialize: function() {
//		if(this.model)
//			this.model.bind("change", this.render, this);
	},
	
	render: function(eventName) {
		if(!this.model)
			return this;
		jQuery(this.el).html(this.template(this.model.toJSON()));
		new app.SelectProjectsView({el: jQuery(this.el).find('#issueProject'), collection: app.Lists.project, selectedValue: this.model.get("project")});
		app.Lists.project.fetch();
		new app.SelectProjectsView({el: jQuery(this.el).find('#issueCategory'), collection: app.Lists.category, selectedValue: this.model.get("category")});
		app.Lists.category.fetch();
		dft = this.model.get("status");
		if(!dft || dft == null || dft.length == 0) {
			for(var i = 0; i < app.Lists.status.length; i++) {
				if(app.Lists.status.at(i).get('dftStatus')) {
					dft = app.Lists.status.at(i).get('_key');
					break;
				}
			}
		}
		new app.SelectProjectsView({el: jQuery(this.el).find('#issueStatus'), collection: app.Lists.status, selectedValue: dft, defaultFirst: true});
		app.Lists.status.fetch();
		var dft = this.model.get("priority");
		if(!dft || dft == null || dft.length == 0) {
			for(var i = 0; i < app.Lists.priority.length; i++) {
				if(app.Lists.priority.at(i).get('dftPriority')) {
					dft = app.Lists.priority.at(i).get('_key');
					break;
				}
			}
		}
		new app.SelectProjectsView({el: jQuery(this.el).find('#issuePriority'), collection: app.Lists.priority, selectedValue: dft, defaultFirst: true});
		app.Lists.priority.fetch();
		new app.SelectProjectsView({el: jQuery(this.el).find('#issueAssigned'), collection: app.Lists.user, selectedValue: this.model.get("assigned")}).addAll();
		setTimeout(uploadButton, 100);
		setTimeout(function(){CKEDITOR.replace('issueDesc');}, 100);
		return this;
	},
	
	events: {
		"change input": "change",
		"change select": "change",
		"click .save": "saveIssue"
	},
	
	change: function(event) {
		var target = event.target;
		//console.log('changing ' + target.id + ' from: ' + target.defalutValue + ' to: ' + target.value);
		if(target.id == 'issueCategory' || target.id == 'issueProject') {
			var cat = app.Lists.category.get(jQuery('#issueCategory').val());
			var prj = app.Lists.project.get(jQuery('#issueProject').val());
			var dv = null;
			if(cat) {
				var dft = cat.get('dftAssigned');
				if(dft && dft != null && dft.length > 0)
					dv = dft;
			}
			if(dv === null && prj) {
				var dft = prj.get('dftAssigned');
				if(dft && dft != null && dft.length > 0)
					dv = dft;
			}
			if(dv != null)
				jQuery('#issueAssigned').val(dv);
		}
	},
	
	saveIssue: function() {
		this.model.set({
			title: jQuery('#issueTitle').val(),
			project: jQuery('#issueProject').val(),
			category: jQuery('#issueCategory').val(),
			status: jQuery('#issueStatus').val(),
			priority: jQuery('#issuePriority').val(),
			assigned: jQuery('#issueAssigned').val(),
			description: CKEDITOR.instances.issueDesc.getData()
		});
		if(this.model.isValid()) {
			if(this.model.isNew()) {
				var me = this;
				app.PR.issueList.create(this.model, {
					success: function() {
						if(app.AttachTab && app.AttachTab !== null) {
							var key = me.model.id;
							for(var i = 0; i < app.AttachTab.model.length; i++) {
								var attach = app.AttachTab.model.at(i);
								attach.save({
									dataKind: 'issue',
									dataKey: key
								});
							}
							jQuery('#listAttachment').html('');
							app.AttachTab = null;
						}
						app.PR.navigate('issue/' + me.model.id, true);
					}
				});
			} else 
				this.model.save();
		} else
			alert(this.model.validationError);
		return false;
	},
	
	close: function() {
		jQuery(this.el).unbind();
		jQuery(this.el).empty();
	}
});

// Issue-Detial-Change View
app.IssueChangeView = Backbone.View.extend({
		
	template: _.template(jQuery('#tpl-issue-detail-change').html()),
	
	initialize: function() {
		if(this.model)
			this.model.bind("change", this.render, this);
		this.lstChanges = [];
	},
	
	render: function(eventName) {
		if(!this.model)
			return this;
		var obj = this.model.toJSON(), r;
		obj.statusDesc = (obj.status ? (r = app.Lists.status.get(obj.status)) ? r.get("name") : '' : '');
		obj.priorityDesc = (obj.priority ? (r = app.Lists.priority.get(obj.priority)) ? r.get("name") : '' : '');
		obj.projectDesc = (obj.project ? (r = app.Lists.project.get(obj.project)) ? r.get("name") : '' : '');
		obj.categoryDesc = (obj.category ? (r = app.Lists.category.get(obj.category)) ? r.get("name") : '' : '');
		obj.createUserName = (obj.createUser ? (r = app.Lists.user.get(obj.createUser)) ? r.get("name") : '' : '');
		obj.assignedName = (obj.assigned ? (r = app.Lists.user.get(obj.assigned)) ? r.get("name") : '' : '');
		obj.createDatum = new Date(obj.createDate).toString("dd.MM.yyyy HH:mm"); 
		jQuery(this.el).html(this.template(obj));
		new app.SelectProjectsView({el: jQuery(this.el).find('#issueProject'), collection: app.Lists.project, selectedValue: this.model.get("project")});
		app.Lists.project.fetch();
		new app.SelectProjectsView({el: jQuery(this.el).find('#issueCategory'), collection: app.Lists.category, selectedValue: this.model.get("category")});
		app.Lists.category.fetch();
		new app.SelectProjectsView({el: jQuery(this.el).find('#issueStatus'), collection: app.Lists.status, selectedValue: this.model.get("status"), defaultFirst: true});
		app.Lists.status.fetch();
		new app.SelectProjectsView({el: jQuery(this.el).find('#issuePriority'), collection: app.Lists.priority, selectedValue: this.model.get("priority"), defaultFirst: true});
		app.Lists.priority.fetch();
		new app.SelectProjectsView({el: jQuery(this.el).find('#issueAssigned'), collection: app.Lists.user, selectedValue: this.model.get("assigned")}).addAll();
		setTimeout(uploadButton, 100);
		setTimeout(function(){CKEDITOR.replace('issueDesc');}, 100);
		var me = this;
		setTimeout(function(){me.renderReply(me);}, 100);
		return this;
	},
	
	events: {
		"change input": "change",
		"change select": "change",
		"click .save": "saveIssue",
		"click .print": "printIssue"
	},
	
	change: function(event) {
		var target = event.target;
		//console.log('changing ' + target.id + ' from: ' + target.defalutValue + ' to: ' + target.value);
		if(this.lstChanges[target.name] === undefined)
			this.lstChanges[target.name] = {};
		this.lstChanges[target.name].oldValue = this.model.get(target.name);
		this.lstChanges[target.name].newValue = target.value;
		if(target.id == 'issueStatus') {
			var sta = app.Lists.status.get(jQuery('#issueStatus').val());
			if(sta) {
				var dft = sta.get('backToCreator');
				if(dft && dft != null) {
					if(this.lstChanges['assigned'] === undefined)
						this.lstChanges['assigned'] = {};
					this.lstChanges['assigned'].oldValue = this.model.get('assigned');
					jQuery('#assigned').val(this.model.get('createUser'));
					this.lstChanges['assigned'].newValue = this.model.get('createUser');
				}
			}
		}
	},
	
	saveIssue: function() {
		var txt = '', title = '';
		var chgData = {};
		for(var fld in this.lstChanges) {
			var obj = this.lstChanges[fld];
			switch(fld) {
			case "title":
				txt = txt + 'Der Titel wurde geändert von "' + obj.oldValue + '" auf "' + obj.newValue + '"<br>';
				title = title + (title.length > 0 ? ', ' : '') + 'Titel';
				chgData.title = obj.newValue;
				break;
			case "project":
				txt = txt + 'Das Projekt wurde geändert von "' + app.Lists.project.get(obj.oldValue).get('name') + '" auf "' + app.Lists.project.get(obj.newValue).get('name') + '"<br>';
				title = title + (title.length > 0 ? ', ' : '') + 'Projekt';
				chgData.project = obj.newValue;
				break;
			case "category":
				txt = txt + 'Die Kategorie wurde geändert von "' + app.Lists.category.get(obj.oldValue).get('name') + '" auf "' + app.Lists.category.get(obj.newValue).get('name') + '"<br>';
				title = title + (title.length > 0 ? ', ' : '') + 'Kategorie';
				chgData.category = obj.newValue;
				break;
			case "status":
				txt = txt + 'Der Status wurde geändert von "' + app.Lists.status.get(obj.oldValue).get('name') + '" auf "' + app.Lists.status.get(obj.newValue).get('name') + '"<br>';
				title = title + (title.length > 0 ? ', ' : '') + 'Status';
				chgData.status = obj.newValue;
				break;
			case "priority":
				txt = txt + 'Die Priorität wurde geändert von "' + app.Lists.priority.get(obj.oldValue).get('name') + '" auf "' + app.Lists.priority.get(obj.newValue).get('name') + '"<br>';
				title = title + (title.length > 0 ? ', ' : '') + 'Priorität';
				chgData.priority = obj.newValue;
				break;
			case "assigned":
				txt = txt + 'Zugewiesen an wurde geändert von "' + app.Lists.user.get(obj.oldValue).get('name') + '" auf "' + app.Lists.user.get(obj.newValue).get('name') + '"<br>';
				title = title + (title.length > 0 ? ', ' : '') + 'Zugewiesen an';
				chgData.assigned = obj.newValue;
				break;
			}
		}
		var me = this;
		if(txt.length > 0) {
			title = title + ' wurde aktualisiert';
			var reply = new app.Reply();
			reply.set({
				title: title, 
				text: txt,
				createUser: app.curUser.name,
				createDate: Date.now(),
				issueKey: this.model.get("_key")
			});
			reply.save();
			this.model.set(chgData);
			this.model.save();
			this.colReply.add(reply);
		}
		txt = CKEDITOR.instances.issueDesc.getData();
		if(txt && txt.length > 0) {
			var reply = new app.Reply();
			reply.save({
				title: 'Antwort', 
				text: txt,
				createUser: app.curUser.name,
				createDate: Date.now(),
				issueKey: this.model.get("_key")
			}, {
				success: function(model) {
					if(app.AttachTab && app.AttachTab !== null) {
						for(var i = 0; i < app.AttachTab.model.length; i++) {
							var attach = app.AttachTab.model.at(i);
							attach.save({
								dataKind: 'reply',
								dataKey: model.id
							});
						}
						jQuery('#listAttachment').html('');
						app.AttachTab = null;
						me.colReply.add(reply);
					} else
						me.colReply.add(reply);
				}
			});
			
		} else if(app.AttachTab && app.AttachTab !== null && app.AttachTab.model.length > 0) {
			var reply = new app.Reply();
			reply.save({
				title: 'Anhang', 
				text: 'Es wurden zusätzliche Anhänge hinzugefügt.',
				createUser: app.curUser.name,
				createDate: Date.now(),
				issueKey: this.model.get("_key")
			}, {
				success: function(model) {
					if(app.AttachTab && app.AttachTab !== null) {
						for(var i = 0; i < app.AttachTab.model.length; i++) {
							var attach = app.AttachTab.model.at(i);
							attach.save({
								dataKind: 'reply',
								dataKey: model.id
							});
						}
						jQuery('#listAttachment').html('');
						app.AttachTab = null;
						me.colReply.add(reply);
					} else
						me.colReply.add(reply);
				}
			});
		}
		return false;
	},
	
	close: function() {
		jQuery(this.el).unbind();
		jQuery(this.el).empty();
	},
	
	renderReply: function(mep) {
		var me = (mep || this);
		me.colReply = new app.ReplyCollection();
		me.colReply.fetch({data: {filter: 'x.issueKey=="' + me.model.get("_key") + '"'}});
		jQuery('#issueReplies').html(new app.ReplyListView({model: me.colReply}).render().el);
		var colAtt = new app.AttachmentCollection();
		colAtt.fetch({data: {filter: 'x.dataKind=="issue" && x.dataKey=="' + me.model.get("_key") + '"'}});
		jQuery('#issueAttachments').html(new app.AttachmentListView({model: colAtt}).render().el);
	},
	
	printIssue: function() {
		jQuery("#editReply").hide();
		jQuery("#issueHeader").hide();
		jQuery("#issueContent").removeClass("issueContent").addClass("issueContentPrint");
		jQuery("#issueReplies").removeClass("issueReplyList");
		setTimeout(function() { 
			window.print();
			jQuery("#issueReplies").addClass("issueReplyList");
			jQuery("#issueContent").removeClass("issueContentPrint").addClass("issueContent");
			jQuery("#issueHeader").show();
			jQuery("#editReply").show();
		}, 200);
	}
});

app.IssueHeaderView = Backbone.View.extend({
		
	template: _.template(jQuery('#tpl-issue-header').html()),
	
	initialize: function() {
		this.render();
	},
	
	render: function(eventName) {
		if(!this.isRender) {
			this.isRender = true;
			jQuery(this.el).html(this.template());
			setTimeout(function() {
				new app.SelectProjectsView({el: jQuery('#issueFilterStatus'), collection: app.Lists.status, selectedValue: '', defaultFirst: true});
				new app.SelectProjectsView({el: jQuery('#issueFilterProject'), collection: app.Lists.project, selectedValue: '', defaultFirst: false});
				new app.SelectProjectsView({el: jQuery('#issueFilterCategory'), collection: app.Lists.category, selectedValue: '', defaultFirst: false});
			}, 250);
		}
		return this;
	},
	
	events: {
		"click .new": "newIssue",
		"click .refresh": "refreshIssue"
	},
	
	newIssue: function(event) {
		app.PR.navigate("issue/new", true);
		return false;
	},
	
	refreshIssue: function(event) {
		Backbone.history.fragment = '';
		app.PR.navigate("issue/list", true);
		return false;
	}
});

app.SelectProjectView = Backbone.View.extend({
		
	tagName: 'option',
	
	initialize: function(options) {
		_.bindAll(this, 'render');
		this.selectedValue = options.selectedValue;
	},
	
	render: function() {
		jQuery(this.$el).attr('value', this.model.get('_key'))
			.attr('selected', this.selectedValue == this.model.get('_key') || this.defaultFirst).html(this.model.get('name'));
		return this;
	}
});

app.SelectProjectsView = Backbone.View.extend({
	
	initialize: function(options) {
		_.bindAll(this, 'addOne', 'addAll');
		this.collection.bind('reset', this.addAll);
		this.collection.bind('sync', this.addAll);
		//this.collection.bind('add', this.addOne);
		this.selectedValue = options.selectedValue;
		this.defaultFirst = (options.defaultFirst && this.selectedValue == '');
		if(!this.childKey)
			this.childKey = [];
		this.addAll();
	},
	
	addOne: function(project) {
		if(_.indexOf(this.childKey, project.get("_key")) < 0) {
			if(this.defaultFirst)
				this.selectedValue = project.get("_key");
			jQuery(this.$el).append(new app.SelectProjectView({model: project, selectedValue: this.selectedValue}).render().el);
			this.defaultFirst = false;
			this.childKey[this.childKey.length] = project.get("_key");
		}
	},
	
	addAll: function() {
		this.collection.each(this.addOne);
	}
});

// Reply Model
// ----------

app.Reply = Backbone.Model.extend({
	defaults: {
		_key: null,
		title: '',
		text: '',
		createUser: '',
		createDate: '',
		issueKey: ''
	},
	idAttribute: '_key',

	url: function() {
		if (this.get("_key") !== undefined && this.get("_key") !== null) {
			return 'reply/' + encodeURIComponent(this.get("_key"));
		}
		this.set("_key", undefined);
		return 'reply';
	},

	isNew: function() {
		return (this.get("_key") === undefined || this.get("_key") === null);
	},
	
	validate: function(attrs, options) {
		if(attrs.title === undefined || attrs.title === null || attrs.title.trim().length == 0)
			return "Bitte einen Titel eingeben.";
		if(attrs.text === undefined || attrs.text === null || attrs.text.trim().length == 0)
			return "Bitte einen Text eingeben.";
	}
});

// Reply Collection
// ---------------

app.ReplyCollection = Backbone.Collection.extend({
	model: app.Reply,
	
	url: "reply",

	comparator: function (issue) {
		return issue.get('createDate');
	}
});

// Reply List View
app.ReplyListView = Backbone.View.extend({
		
	tagName: 'div',

	initialize: function() {
		this.model.bind("reset", this.render, this);
		var me = this;
		this.model.bind("add", function(issue) {
			jQuery(me.el).prepend(new app.ReplyListItemView({model: issue}).render().el);
		});
	},
	
	render: function(eventName) {
		for(var i = this.model.length - 1; i >= 0; i--) {
			var reply = this.model.at(i);
			jQuery(this.el).append(new app.ReplyListItemView({model: reply}).render().el);
		}
		return this;
	}
});


// Reply List Item View
app.ReplyListItemView = Backbone.View.extend({
	
	tagName: 'div',
	className: 'issueReply',
	
	template: _.template(jQuery('#tpl-reply-list-item').html()),
	
	initialize: function() {
		this.model.bind("change", this.render, this);
		this.model.bind("destroy", this.close, this);
	},
	
	render: function(eventName) {
		var obj = this.model.toJSON(), r;
		obj.createUserName = (obj.createUser ? (r = app.Lists.user.get(obj.createUser)) ? r.get("name") : '' : '');
		obj.createDatum = new Date(obj.createDate).toString("dd.MM.yyyy HH:mm"); 
		jQuery(this.el).html(this.template(obj));
		var me = this;
			var colAtt = new app.AttachmentCollection();
			colAtt.fetch({
				data: {filter: 'x.dataKind=="reply" && x.dataKey=="' + me.model.get("_key") + '"'},
				success: function() {
					if(colAtt.length > 0) {
						jQuery(me.el).find('.replyAttachmentList').html(new app.AttachmentListView({model: colAtt}).render().el);
						jQuery(me.el).find('.replyAttachmentList').show();
					} 
				}
			});
		return this;
	},
	
	close: function() {
		jQuery(this.el).unbind();
		jQuery(this.el).remove();
	}
});


// Attachment Model
// ----------

app.Attachment = Backbone.Model.extend({
	defaults: {
		_key: null,
		name: '',
		size: 0,
		description: '',
		contentType: '',
		originalName: '',
		dataKind: '',
		dataKey: ''
	},
	idAttribute: '_key',

	url: function() {
		if (this.get("_key") !== undefined && this.get("_key") !== null) {
			return 'attachment/' + encodeURIComponent(this.get("_key"));
		}
		this.set("_key", undefined);
		return 'attachment';
	},

	isNew: function() {
		return (this.get("_key") === undefined || this.get("_key") === null);
	}
});

// Attachment Collection
// ---------------

app.AttachmentCollection = Backbone.Collection.extend({
	model: app.Attachment,
	
	url: "attachment",

	comparator: function (issue) {
		return issue.get('originalName');
	}
});

// Attachment List View
app.AttachmentListView = Backbone.View.extend({
		
	tagName: 'div',
	className: 'tabelle',

	initialize: function() {
		this.model.bind("reset", this.render, this);
		var me = this;
		this.model.bind("add", function(issue) {
			jQuery(me.el).prepend(new app.AttachmentListItemView({model: issue}).render().el);
		});
	},
	
	render: function(eventName) {
		_.each(this.model.models, function(issue) {
			jQuery(this.el).append(new app.AttachmentListItemView({model: issue}).render().el);
		}, this);
		return this;
	}
});


// Issue List Item View
app.AttachmentListItemView = Backbone.View.extend({
	
	tagName: 'div',
	className: 'tabelleZeile',
	
	template: _.template(jQuery('#tpl-attachment-list-item').html()),
	
	initialize: function() {
		this.model.bind("change", this.render, this);
		this.model.bind("destroy", this.close, this);
	},
	
	render: function(eventName) {
		jQuery(this.el).html(this.template(this.model.toJSON()));
		return this;
	},
	
	close: function() {
		jQuery(this.el).unbind();
		jQuery(this.el).remove();
	}
});


//////////////////////////////////////////////////////////////////////

// Router
// ----------
var AppRouter = Backbone.Router.extend({
	routes: {
		'': 'listFilterIssue',
		'project/list': 'listProject',
		'project/new': 'newProject',
		'project/:id': 'projectDetails',
		'category/list': 'listCategory',
		'category/new': 'newCategory',
		'category/:id': 'categoryDetails',
		'issue/listFilterUser': 'listFilterIssue',
		'issue/list': 'listFilterIssue',
		'issue/list/:sort': 'listFilterIssue',
		'issue/new': 'newIssue',
		'issue/:id': 'issueDetails',		
		'status/list': 'listStatus',
		'status/new': 'newStatus',
		'status/:id': 'statusDetails',		
		'priority/list': 'listPriority',
		'priority/new': 'newPriority',
		'priority/:id': 'priorityDetails',		
		'user/list': 'listUser',
		'user/new': 'newUser',
		'user/:id': 'userDetails'		
	},
	
	initialize: function() {
		jQuery('#projectHeader').html(new app.ProjectHeaderView().render().el);
		jQuery('#categoryHeader').html(new app.CategoryHeaderView().render().el);
		jQuery('#issueHeader').html(new app.IssueHeaderView().render().el);
		jQuery('#statusHeader').html(new app.StatusHeaderView().render().el);
		jQuery('#priorityHeader').html(new app.PriorityHeaderView().render().el);
		jQuery('#userHeader').html(new app.UserHeaderView().render().el);
		
		this.statusList = new app.StatusCollection();
		this.statusList.fetch();
	},

	_isLogin: function() {
		return (app.curUser && app.curUser.name != 'anonymous');
	},
	/*setFilter: function (param) {
		// Set the current filter to be used
		app.ProjectFilter = param || '';

		// Trigger a collection filter event, causing hiding/unhiding
		// of Todo view items
		app.Projects.trigger('filter');
	}*/
	
	listProject: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(!this.projectList)
			this.projectList = new app.ProjectCollection();
		var me = this;
		this.projectList.fetch({
			success: function() {
				me.projectListView = new app.ProjectListView({model: me.projectList});
				jQuery('#projectSidebar').html(me.projectListView.render().el);
				if(me.requestedProjectId) {
					me.projectDetails(me.requestedProjectId);
					me.requestedProjectId = undefined;
				}
			}
		});
	},
	
	projectDetails: function(id) {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.projectList) {
			this.project = this.projectList.get(id);
			if(this.projectView)
				this.projectView.setModel(this.project);
			else {
				this.projectView = new app.ProjectView({model: this.project, collection: this.projectList});
				jQuery('#projectContent').html(this.projectView.render().el);
			}
		} else {
			this.requestedProjectId = id;
			this.listProject();
		}
	},
	
	newProject: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.projectView)
			this.projectView.setModel(new app.Project());
		else {
			if(!this.projectList)
				this.projectList = new app.ProjectCollection();
			this.projectView = new app.ProjectView({model: new app.Project(), collection: this.projectList});
			jQuery('#projectContent').html(this.projectView.render().el);
		}
	},
	
	listCategory: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(!this.categoryList)
			this.categoryList = new app.CategoryCollection();
		var me = this;
		this.categoryList.fetch({
			success: function() {
				me.categoryListView = new app.CategoryListView({model: me.categoryList, collection: this.categoryList});
				jQuery('#categorySidebar').html(me.categoryListView.render().el);
				if(me.requestedCategoryId) {
					me.categoryDetails(me.requestedCategoryId);
					me.requestedCategoryId = undefined;
				}
			}
		});
	},
	
	categoryDetails: function(id) {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.categoryList) {
			this.category = this.categoryList.get(id);
			if(this.categoryView)
				this.categoryView.setModel(this.category);
			else if(this.category) {
				this.categoryView = new app.CategoryView({model: this.category, collection: this.categoryList});
				jQuery('#categoryContent').html(this.categoryView.render().el);
			}
		} else {
			this.requestedCategoryId = id;
			this.listCategory();
		}
	},
	
	newCategory: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.categoryView)
			this.categoryView.setModel(new app.Category());
		else {
			if(!this.categoryList)
				this.categoryList = new app.CategoryCollection();
			this.categoryView = new app.CategoryView({model: new app.Category(), collection: this.categoryList});
			jQuery('#categoryContent').html(this.categoryView.render().el);
		}
	},

	listIssue: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		this.issueList = new app.IssueCollection();
		var me = this;
		this.issueList.fetch({
			success: function() {
				if(me.issueListView)
					me.issueListView.setModel(me.issueList);
				else {
					me.issueListView = new app.IssueListView({model: me.issueList});
					jQuery('#issueSidebar').html(me.issueListView.render().el);
				}
				if(me.requestedIssueId) {
					me.issueDetails(me.requestedIssueId);
					me.requestedIssueId = undefined;
				}
			}
		});
		if(this.issueView) {
			this.issueView.close();
			this.issueView = undefined;
		}
		jQuery('#issueContent').hide();
		jQuery('#issueSidebar').show();
	},

	listFilterIssue: function(sort) {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		this.issueList = new app.IssueCollection();
		var me = this;
		var query = '';
		switch(jQuery('#issueFilterUser').val()) {
		case 'all':
			break;
		case 'own':
			query = 'x.createUser=="' + app.curUser.name + '"';
			break;
		case 'assigned':
			query = 'x.assigned=="' + app.curUser.name + '"';
			break;
		}
		if(jQuery('#issueFilterStatus').val() != 'all') {
			if(query.length > 0)
				query = query + ' && ';
			query = query + 'x.status=="' + jQuery('#issueFilterStatus').val() + '"';
		}
		if(jQuery('#issueFilterProject').val() != 'all') {
			if(query.length > 0)
				query = query + ' && ';
			query = query + 'x.project=="' + jQuery('#issueFilterProject').val() + '"';
		}
		if(jQuery('#issueFilterCategory').val() != 'all') {
			if(query.length > 0)
				query = query + ' && ';
			query = query + 'x.category=="' + jQuery('#issueFilterCategory').val() + '"';
		}
		var daten = {};
		if(query.length > 0)
			daten.filter = query;
		if(sort)
			daten.sort = sort;
		var ftxt = jQuery('#issueFilterFulltext').val();
		if(ftxt && ftxt !== null && ftxt.trim().length > 0)
			daten.fullsearch = ftxt;
		this.issueList.fetch({
			success: function() {
				if(me.issueListView)
					me.issueListView.setModel(me.issueList);
				else {
					me.issueListView = new app.IssueListView({model: me.issueList});
					jQuery('#issueSidebar').html(me.issueListView.render().el);
				}
				if(me.requestedIssueId) {
					me.issueDetails(me.requestedIssueId);
					me.requestedIssueId = undefined;
				}
			},
			data: daten
		});
		if(this.issueView) {
			this.issueView.close();
			this.issueView = undefined;
		}
		jQuery('#issueContent').hide();
		jQuery('#issueSidebar').show();
	},
	
	issueDetails: function(id) {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.issueList) {
			this.issue = this.issueList.get(id);
			if(this.issueView)
				this.issueView.close();
			this.issueView = new app.IssueChangeView({model: this.issue});
			jQuery('#issueContent').html(this.issueView.render().el);
			
			jQuery('#issueSidebar').hide();
			jQuery('#issueContent').show();
		} else {
			this.requestedIssueId = id;
			this.listIssue();
		}
	},
	
	newIssue: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.issueView)
			this.issueView.close();
		this.issueView = new app.IssueView({model: new app.Issue({
			createUser: app.curUser.name,
			createDate: Date.now()
		})});
		jQuery('#issueContent').html(this.issueView.render().el);
		jQuery('#issueSidebar').hide();
		jQuery('#issueContent').show();
	},
	
	listStatus: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(!this.statusList)
			this.statusList = new app.StatusCollection();
		var me = this;
		this.statusList.fetch({
			success: function() {
				me.statusListView = new app.StatusListView({model: me.statusList});
				jQuery('#statusSidebar').html(me.statusListView.render().el);
				if(me.requestedStatusId) {
					me.statusDetails(me.requestedStatusId);
					me.requestedStatusId = undefined;
				}
			}
		});
	},
	
	statusDetails: function(id) {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.statusList) {
			this.status = this.statusList.get(id);
			if(this.statusView)
				this.statusView.setModel(this.status);
			else if(this.status) {
				this.statusView = new app.StatusView({model: this.status, collection: this.statusList});
				jQuery('#statusContent').html(this.statusView.render().el);
			}
		} else {
			this.requestedStatusId = id;
			this.listStatus();
		}
	},
	
	newStatus: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.statusView)
			this.statusView.setModel(new app.Status());
		else {
			if(!this.statusList)
				this.statusList = new app.StatusCollection();
			this.statusView = new app.StatusView({model: new app.Status(), collection: this.statusList});
			jQuery('#statusContent').html(this.statusView.render().el);
		}
	},

	listPriority: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(!this.priorityList)
			this.priorityList = new app.PriorityCollection();
		var me = this;
		this.priorityList.fetch({
			success: function() {
				me.priorityListView = new app.PriorityListView({model: me.priorityList});
				jQuery('#prioritySidebar').html(me.priorityListView.render().el);
				if(me.requestedPriorityId) {
					me.priorityDetails(me.requestedPriorityId);
					me.requestedPriorityId = undefined;
				}
			}
		});
	},
	
	priorityDetails: function(id) {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.priorityList) {
			this.priority = this.priorityList.get(id);
			if(this.priorityView)
				this.priorityView.setModel(this.priority);
			else if(this.priority) {
				this.priorityView = new app.PriorityView({model: this.priority, collection: this.priorityList});
				jQuery('#priorityContent').html(this.priorityView.render().el);
			}
		} else {
			this.requestedPriorityId = id;
			this.listPriority();
		}
	},
	
	newPriority: function() {
		if(!this._isLogin()) {
			Backbone.history.fragment = '';
			return;
		}
		if(this.priorityView)
			this.priorityView.setModel(new app.Priority());
		else {
			if(!this.priorityList)
				this.priorityList = new app.PriorityCollection();
			this.priorityView = new app.PriorityView({model: new app.Priority(), collection: this.priorityList});
			jQuery('#priorityContent').html(this.priorityView.render().el);
		}
	},
	
	listUser: function() {
		if(app.curUser.data && app.curUser.data.admin) {
			if(!this.userListView) {
				this.userListView = new app.UserListView({model: app.Lists.user});
				jQuery('#userSidebar').html(this.userListView.render().el);
			}
		}
	},
	
	userDetails: function(id) {
		if(app.curUser.data && app.curUser.data.admin) {
			if(app.Lists.user) {
				this.user = app.Lists.user.get(id);
				if(this.userView)
					this.userView.setModel(this.user);
				else if(this.user) {
					this.userView = new app.UserView({model: this.user, collection: app.Lists.user});
					jQuery('#userContent').html(this.userView.render().el);
				}
			}
		}
	},
	
	newUser: function() {
		if(app.curUser.data && app.curUser.data.admin) {		
			if(this.userView)
				this.userView.setModel(new app.User());
			else {
				this.userView = new app.UserView({model: new app.User(), collection: app.Lists.user});
				jQuery('#userContent').html(this.userView.render().el);
			}
		}
	}
	
});

function get_url_param(name) {
	name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");

	var regexS = "[\\?&]" + name + "=([^&#]*)";
	var regex = new RegExp(regexS);
	var results = regex.exec(window.location.href);

	if (results == null)
			return "";
	else
			return results[1];
}

jQuery( document ).ready(function() {
	sitsLogin();
	
	var lastMenu = "issue";
	jQuery('#menuMain').change(function () {
		jQuery('#' + lastMenu + 'dlg').hide();
		lastMenu = jQuery('#menuMain').val();
		jQuery('#' + lastMenu + 'dlg').show();
		app.PR.navigate(lastMenu + "/list", true);
	});
	
	app.Lists.status = new app.StatusCollection();
	app.Lists.status.fetch();
	app.Lists.priority = new app.PriorityCollection();
	app.Lists.priority.fetch();
	app.Lists.project = new app.ProjectCollection();
	app.Lists.project.fetch();
	app.Lists.category = new app.CategoryCollection();
	app.Lists.category.fetch();
	
	app.PR = new AppRouter();
	Backbone.history.start();
	
});

