Date.prototype.getCalendarWeek = function() {
  var cwDate = new Date(this);
  var doDat = new Date(cwDate.getTime() + (3-((cwDate.getDay()+6) % 7)) * 86400000);
	cwYear = doDat.getFullYear();
	var doCW = new Date(new Date(cwYear,0,4).getTime() + (3-((new Date(cwYear,0,4).getDay()+6) % 7)) * 86400000);
	cw = Math.floor(1.5+(doDat.getTime()-doCW.getTime())/86400000/7);
	return cw;
};
Date.prototype.addDays = function(days) {
  this.setTime(this.getTime() + (days * 24 * 60 * 60 * 1000));
  return this;
};
Date.prototype.equalDate = function(datum) {
	return (datum && this.getFullYear() == datum.getFullYear() && 
			this.getMonth() == datum.getMonth() && this.getDate() == this.getDate());
};
Date.prototype.betweenDate = function(von, bis, onlyDate) {
	var d;
	if(onlyDate)
		d = new Date(this.getFullYear(), this.getMonth(), this.getDate(), 0, 0, 0, 0);
	else
		d = this;
	return (von && bis && d.getTime() >= von.getTime() && d.getTime() <= bis.getTime());
};

(function () {
  'use strict';
  function f(n) {
      // Format integers to have at least two digits.
    if(n < 0)
        return '-' + f(n*(-1));
     return n < 10 ? '0' + n : n;
  }

  Date.prototype.toJSON = function () {
    /*var zs = this.getTimezoneOffset() / 60;
    var zm = this.getTimezoneOffset() % 60;
    return isFinite(this.valueOf())
        ? this.getUTCFullYear()     + '-' +
            f(this.getUTCMonth() + 1) + '-' +
            f(this.getUTCDate())      + 'T' +
            f(this.getUTCHours())     + ':' +
            f(this.getUTCMinutes())   + ':' +
            f(this.getUTCSeconds())   + 'Z' +
            (zs>=0 ? '+':'')+f(zs)+f(zm)
        : null;*/
    return isFinite(this.valueOf()) ?
            this.getFullYear()     + '-' +
            f(this.getMonth() + 1) + '-' +
            f(this.getDate())      + 'T' +
            f(this.getHours())     + ':' +
            f(this.getMinutes())   + ':' +
            f(this.getSeconds())
        : null;
  };
}());

Date.prototype._toString = Date.prototype.toString;

Date.prototype.toString = function(format) {
  var self=this;
  var p=function p(s){return(s.toString().length==1)?"0"+s:s;};
  return format?format.replace(/dd?d?d?|MM?M?M?|yy?y?y?|hh?|HH?|mm?|ss?|tt?|zz?z?/g, function(format) {
    switch(format) {
      case"hh":return p(self.getHours()<13?self.getHours():(self.getHours()-12));
      case"h":return self.getHours()<13?self.getHours():(self.getHours()-12);
      case"HH":return p(self.getHours());
      case"H":return self.getHours();
      case"mm":return p(self.getMinutes());
      case"m":return self.getMinutes();
      case"ss":return p(self.getSeconds());
      case"s":return self.getSeconds();
      case"yyyy":return self.getFullYear();
      case"yy":return self.getFullYear().toString().substring(2,4);
      //case"dddd":return self.getDayName();
      //case"ddd":return self.getDayName(true);
      case"dd":return p(self.getDate());
      case"d":return self.getDate().toString();
      //case"MMMM":return self.getMonthName();
      //case"MMM":return self.getMonthName(true);
      case"MM":return p((self.getMonth()+1));
      case"M":return self.getMonth()+1;
      //case"t":return self.getHours()<12?Date.CultureInfo.amDesignator.substring(0,1):Date.CultureInfo.pmDesignator.substring(0,1);
      //case"tt":return self.getHours()<12?Date.CultureInfo.amDesignator:Date.CultureInfo.pmDesignator;      
      case"zzz":
      case"zz":
      case"z":return"";      
    }    
  }):this._toString();
};

